#ifndef XS_TEST_EXPECTATION_H_INCLUDED
#define XS_TEST_EXPECTATION_H_INCLUDED

#include "pgjson/pgjson.hpp"

#include <boost/optional.hpp>

#include <string>
#include <unordered_set>


namespace xs { namespace test
{
    class Expectation final
    {
    public:
        Expectation() = delete;
        Expectation(const Expectation&) = delete;
        Expectation(Expectation&&) = default;
        ~Expectation() noexcept = default;

        Expectation& operator=(const Expectation&) = delete;
        Expectation& operator=(Expectation&&) = delete;

        explicit Expectation(const pgjson::CValue& object);
        static bool verify(const pgjson::CValue& object) noexcept;

    public:
        std::string name_;
        pgjson::CValue request_;
        boost::optional<pgjson::CValue> response_;
        std::unordered_set<std::string> runs_;
        std::unordered_set<std::string> posts_;
    };
} }

#endif
