#ifndef XS_TEST_SERVER_H_INCLUDED
#define XS_TEST_SERVER_H_INCLUDED

#include <string>

#include <boost/optional.hpp>

#include "pgjson/pgjson.hpp"


namespace xs { namespace test
{
    class Service final
    {
    public:
        Service() = delete;
        Service(const Service&) = delete;
        Service(Service&&) = default;
        ~Service() noexcept = default;

        Service& operator=(const Service&) = delete;
        Service& operator=(Service&&) = delete;

        explicit Service(const pgjson::CValue& object);
        static bool verify(const pgjson::CValue& object) noexcept;

        bool isCommand() const noexcept;
        bool isEvent() const noexcept;

    private:
        Service(std::string name, pgjson::CValue response) noexcept;
        Service(std::string name) noexcept;

    public:
        std::string name_;
        boost::optional<pgjson::CValue> request_;
        boost::optional<pgjson::CValue> response_;
    };
} }

#endif
